$RedHatDrivers = pnputil.exe -e | Select-String -Pattern "Red Hat" -Context 1, 0
$OEMNumbers = $RedHatDrivers.Context.PreContext | Select-String -Pattern "oem\d+\.inf" -AllMatches | % { $_.Matches } | % { $_.Value }
foreach ($OEMNumber in $OEMNumbers) {
    Write-Host "Deleting $OEMNumber"
    pnputil.exe -f -d $OEMNumber
}

Set-Location -Path (Split-Path -Parent -Path $MyInvocation.MyCommand.Definition)

$OSVersion = (Get-WmiObject -Class Win32_OperatingSystem).Version

switch -Regex ($OSVersion) {
    '^6\.0\.' {
        # Vista or Server 2008
        Write-Host "Vista or Server 2008"
        # add sub code
	cd ./Vista_2008/amd64/
    }
    '^6\.1\.' {
        # Win7 or Server 2008 R2
        Write-Host "Win7 or Server 2008 R2"
        # add sub code
	cd ./Win7_2008R2/amd64/
	cmd.exe /c type nul >test.txt
	
    }
    '^6\.2\.' {
        # Win8 or Server 2012
        Write-Host "Win8 or Server 2012"
        # add sub code
	cd ./Win8_2012/amd64/
    }
    '^6\.3\.' {
        # Win8.1 or Server 2012 R2
        Write-Host "Win8.1 or Server 2012 R2"
        # add sub code
	cd ./Win8.1_2012R2/amd64/
    }
    '^10\.' {
        $OSReleaseId = (Get-ItemProperty -Path "HKLM:\SOFTWARE\Microsoft\Windows NT\CurrentVersion").ReleaseId
        if ($OSReleaseId -ge 1607) {
            # Win10 or Win11 or Server 2016 or Server 2019 or Server 2022 or Server vNext
            Write-Host "Win10 or Win11 or Server 2016 or Server 2019 or Server 2022 or Server vNext"
            # add sub code
            cd ./Win10_Win11_2016_2019_2022/amd64/
        }
    }

    default {
        Write-Host "Error"
	Exit
    }
}
pnputil -i -a *.inf